<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/BluetoothImplementations/BlueZ/include/BlueZ/BlueZDeviceManager.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_27114e8c504df5f4609f20f7d28eb6fc.html">BluetoothImplementations</a></li><li class="navelem"><a class="el" href="dir_734f87f436384b5f4d3ce6cedeff05c0.html">BlueZ</a></li><li class="navelem"><a class="el" href="dir_dcc26bf29d4b694c2f1fb3cf2aba65ed.html">include</a></li><li class="navelem"><a class="el" href="dir_6061b9c865ef17da7826af8a1f20a075.html">BlueZ</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">BlueZDeviceManager.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_blue_z_device_manager_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright 2018-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;).</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * You may not use this file except in compliance with the License.</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * A copy of the License is located at</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     http://aws.amazon.com/apache2.0/</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * or in the &quot;license&quot; file accompanying this file. This file is distributed</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> * express or implied. See the License for the specific language governing</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * permissions and limitations under the License.</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#ifndef ALEXA_CLIENT_SDK_BLUETOOTHIMPLEMENTATIONS_BLUEZ_INCLUDE_BLUEZ_BLUEZDEVICEMANAGER_H_</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#define ALEXA_CLIENT_SDK_BLUETOOTHIMPLEMENTATIONS_BLUEZ_INCLUDE_BLUEZ_BLUEZDEVICEMANAGER_H_</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &lt;list&gt;</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &lt;map&gt;</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;mutex&gt;</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_bluetooth_device_interface_8h.html">AVSCommon/SDKInterfaces/Bluetooth/BluetoothDeviceInterface.h</a>&gt;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_bluetooth_device_manager_interface_8h.html">AVSCommon/SDKInterfaces/Bluetooth/BluetoothDeviceManagerInterface.h</a>&gt;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_bluetooth_host_controller_interface_8h.html">AVSCommon/SDKInterfaces/Bluetooth/BluetoothHostControllerInterface.h</a>&gt;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_a2_d_p_source_interface_8h.html">AVSCommon/SDKInterfaces/Bluetooth/Services/A2DPSourceInterface.h</a>&gt;</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_bluetooth_event_bus_8h.html">AVSCommon/Utils/Bluetooth/BluetoothEventBus.h</a>&gt;</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_bluetooth_events_8h.html">AVSCommon/Utils/Bluetooth/BluetoothEvents.h</a>&gt;</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="_requires_shutdown_8h.html">AVSCommon/Utils/RequiresShutdown.h</a>&gt;</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_blue_z_host_controller_8h.html">BlueZ/BlueZHostController.h</a>&quot;</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_blue_z_utils_8h.html">BlueZ/BlueZUtils.h</a>&quot;</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_m_p_r_i_s_player_8h.html">BlueZ/MPRISPlayer.h</a>&quot;</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_pairing_agent_8h.html">BlueZ/PairingAgent.h</a>&quot;</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">#include &lt;gio/gio.h&gt;</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a> {</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="keyword">namespace </span>bluetoothImplementations {</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="keyword">namespace </span>blueZ {</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="keyword">class </span>MediaEndpoint;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="keyword">class </span>BlueZBluetoothDevice;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager.html">   48</a></span>&#160;<span class="keyword">class </span><a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager.html">BlueZDeviceManager</a></div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        : <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1bluetooth_1_1_bluetooth_device_manager_interface.html">avsCommon::sdkInterfaces::bluetooth::BluetoothDeviceManagerInterface</a></div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        , <span class="keyword">public</span> <a class="code" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html">avsCommon::utils::RequiresShutdown</a></div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        , <span class="keyword">public</span> std::enable_shared_from_this&lt;BlueZDeviceManager&gt; {</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keyword">static</span> std::shared_ptr&lt;BlueZDeviceManager&gt; <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager.html#a3e32aae45c2a6cb19ba0a2920c270208">create</a>(</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        std::shared_ptr&lt;avsCommon::utils::bluetooth::BluetoothEventBus&gt; eventBus);</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager.html#a85580a27275ecd4fff32e151dcdd7213">~BlueZDeviceManager</a>() <span class="keyword">override</span>;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    std::shared_ptr&lt;avsCommon::sdkInterfaces::bluetooth::BluetoothHostControllerInterface&gt; <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager.html#a266f614dff792ef62d60a1c049eb0e01">getHostController</a>() <span class="keyword">override</span>;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    std::list&lt;std::shared_ptr&lt;avsCommon::sdkInterfaces::bluetooth::BluetoothDeviceInterface&gt;&gt; <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager.html#a09c419b25ed4b3f0757feb3d9e9d46de">getDiscoveredDevices</a>()</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        <span class="keyword">override</span>;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="comment">// @name RequiresShutdown Functions</span></div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="comment"></span>    <span class="keywordtype">void</span> <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager.html#a481c68aded0e2cd397b7061d3184d916">doShutdown</a>() <span class="keyword">override</span>;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    std::shared_ptr&lt;avsCommon::utils::bluetooth::BluetoothEventBus&gt; <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager.html#a8c5946da10981da8e016c1a9a4179a85">getEventBus</a>();</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    std::shared_ptr&lt;MediaEndpoint&gt; <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager.html#ab275c144eabf33f855b81a1ef4821024">getMediaEndpoint</a>();</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    std::string <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager.html#a49dfc271af291a24d3fea19e5fd69082">getAdapterPath</a>() <span class="keyword">const</span>;</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;    <span class="keyword">explicit</span> <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager.html">BlueZDeviceManager</a>(<span class="keyword">const</span> std::shared_ptr&lt;avsCommon::utils::bluetooth::BluetoothEventBus&gt;&amp; eventBus);</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    <span class="keywordtype">bool</span> init();</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <span class="keywordtype">bool</span> initializeMedia();</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    <span class="keywordtype">bool</span> finalizeMedia();</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;    std::shared_ptr&lt;BlueZBluetoothDevice&gt; addDeviceFromDBusObject(<span class="keyword">const</span> <span class="keywordtype">char</span>* objectPath, GVariant* dbusObject);</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> interfacesAddedCallback(</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        GDBusConnection* conn,</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        <span class="keyword">const</span> gchar* sender_name,</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        <span class="keyword">const</span> gchar* object_path,</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        <span class="keyword">const</span> gchar* interface_name,</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        <span class="keyword">const</span> gchar* signal_name,</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;        GVariant* parameters,</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        gpointer data);</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> interfacesRemovedCallback(</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;        GDBusConnection* conn,</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        <span class="keyword">const</span> gchar* sender_name,</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;        <span class="keyword">const</span> gchar* object_path,</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;        <span class="keyword">const</span> gchar* interface_name,</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;        <span class="keyword">const</span> gchar* signal_name,</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;        GVariant* parameters,</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;        gpointer data);</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;    <span class="keyword">static</span> <span class="keywordtype">void</span> propertiesChangedCallback(</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;        GDBusConnection* conn,</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;        <span class="keyword">const</span> gchar* sender_name,</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;        <span class="keyword">const</span> gchar* object_path,</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;        <span class="keyword">const</span> gchar* interface_name,</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;        <span class="keyword">const</span> gchar* signal_name,</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;        GVariant* parameters,</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;        gpointer data);</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;    <span class="keywordtype">void</span> addDevice(<span class="keyword">const</span> <span class="keywordtype">char</span>* devicePath, std::shared_ptr&lt;BlueZBluetoothDevice&gt; device);</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;    <span class="keywordtype">void</span> removeDevice(<span class="keyword">const</span> <span class="keywordtype">char</span>* devicePath);</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;    <span class="keywordtype">void</span> notifyDeviceAdded(std::shared_ptr&lt;BlueZBluetoothDevice&gt; device);</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;    <span class="keywordtype">void</span> onInterfaceAdded(<span class="keyword">const</span> <span class="keywordtype">char</span>* objectPath, <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html">ManagedGVariant</a>&amp; interfacesChangedMap);</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;    <span class="keywordtype">void</span> onInterfaceRemoved(<span class="keyword">const</span> <span class="keywordtype">char</span>* objectPath);</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;    <span class="keywordtype">void</span> onAdapterPropertyChanged(<span class="keyword">const</span> std::string&amp; path, <span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_g_variant_map_reader.html">GVariantMapReader</a>&amp; changesMap);</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;    <span class="keywordtype">void</span> onDevicePropertyChanged(<span class="keyword">const</span> std::string&amp; path, <span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_g_variant_map_reader.html">GVariantMapReader</a>&amp; changesMap);</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;    <span class="keywordtype">void</span> onMediaStreamPropertyChanged(<span class="keyword">const</span> std::string&amp; path, <span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_g_variant_map_reader.html">GVariantMapReader</a>&amp; changesMap);</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;    std::shared_ptr&lt;BlueZHostController&gt; initializeHostController();</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;    <span class="keywordtype">void</span> onPropertiesChanged(</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;        <span class="keyword">const</span> std::string&amp; propertyOwner,</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;        <span class="keyword">const</span> std::string&amp; objectPath,</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;        <span class="keyword">const</span> <a class="code" href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_g_variant_map_reader.html">GVariantMapReader</a>&amp; changesMap);</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;    <span class="keywordtype">bool</span> getStateFromBlueZ();</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;    std::shared_ptr&lt;BlueZBluetoothDevice&gt; getDeviceByPath(<span class="keyword">const</span> std::string&amp; path) <span class="keyword">const</span>;</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;    <span class="keywordtype">void</span> mainLoopThread();</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;    std::string m_adapterPath;</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;</div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;    std::shared_ptr&lt;DBusProxy&gt; m_objectManagerProxy;</div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;    std::shared_ptr&lt;DBusProxy&gt; m_mediaProxy;</div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;</div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;    std::map&lt;std::string, std::shared_ptr&lt;BlueZBluetoothDevice&gt;&gt; m_devices;</div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;    std::shared_ptr&lt;MediaEndpoint&gt; m_mediaEndpoint;</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;    std::shared_ptr&lt;PairingAgent&gt; m_pairingAgent;</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;    std::shared_ptr&lt;MPRISPlayer&gt; m_mediaPlayer;</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;    std::shared_ptr&lt;avsCommon::utils::bluetooth::BluetoothEventBus&gt; m_eventBus;</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;    <span class="comment">// TODO Having a separate thread for event listening is wasteful. Can optimize with a BlueZ bus listener.</span></div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;<span class="comment"></span>    GMainLoop* m_eventLoop;</div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;    GMainContext* m_workerContext;</div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;</div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;    std::shared_ptr&lt;DBusConnection&gt; m_connection;</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;    <a class="code" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1bluetooth.html#a7717667c8458923f390f6302b54e907a">avsCommon::utils::bluetooth::MediaStreamingState</a> m_streamingState;</div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;</div><div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;    <span class="keyword">mutable</span> std::mutex m_devicesMutex;</div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;</div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;    std::shared_ptr&lt;BlueZHostController&gt; m_hostController;</div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;    std::promise&lt;bool&gt; m_mainLoopInitPromise;</div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;    std::thread m_eventThread;</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;};</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;}  <span class="comment">// namespace blueZ</span></div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;}  <span class="comment">// namespace bluetoothImplementations</span></div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;}  <span class="comment">// namespace alexaClientSDK</span></div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;<span class="preprocessor">#endif  // ALEXA_CLIENT_SDK_BLUETOOTHIMPLEMENTATIONS_BLUEZ_INCLUDE_BLUEZ_BLUEZDEVICEMANAGER_H_</span></div><div class="ttc" id="_bluetooth_host_controller_interface_8h_html"><div class="ttname"><a href="_bluetooth_host_controller_interface_8h.html">BluetoothHostControllerInterface.h</a></div></div>
<div class="ttc" id="_blue_z_utils_8h_html"><div class="ttname"><a href="_blue_z_utils_8h.html">BlueZUtils.h</a></div></div>
<div class="ttc" id="_bluetooth_events_8h_html"><div class="ttname"><a href="_bluetooth_events_8h.html">BluetoothEvents.h</a></div></div>
<div class="ttc" id="_a2_d_p_source_interface_8h_html"><div class="ttname"><a href="_a2_d_p_source_interface_8h.html">A2DPSourceInterface.h</a></div></div>
<div class="ttc" id="_m_p_r_i_s_player_8h_html"><div class="ttname"><a href="_m_p_r_i_s_player_8h.html">MPRISPlayer.h</a></div></div>
<div class="ttc" id="_bluetooth_event_bus_8h_html"><div class="ttname"><a href="_bluetooth_event_bus_8h.html">BluetoothEventBus.h</a></div></div>
<div class="ttc" id="_bluetooth_device_interface_8h_html"><div class="ttname"><a href="_bluetooth_device_interface_8h.html">BluetoothDeviceInterface.h</a></div></div>
<div class="ttc" id="_requires_shutdown_8h_html"><div class="ttname"><a href="_requires_shutdown_8h.html">RequiresShutdown.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager_html_a85580a27275ecd4fff32e151dcdd7213"><div class="ttname"><a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager.html#a85580a27275ecd4fff32e151dcdd7213">alexaClientSDK::bluetoothImplementations::blueZ::BlueZDeviceManager::~BlueZDeviceManager</a></div><div class="ttdeci">virtual ~BlueZDeviceManager() override</div><div class="ttdef"><b>Definition:</b> BlueZDeviceManager.cpp:547</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager_html_a266f614dff792ef62d60a1c049eb0e01"><div class="ttname"><a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager.html#a266f614dff792ef62d60a1c049eb0e01">alexaClientSDK::bluetoothImplementations::blueZ::BlueZDeviceManager::getHostController</a></div><div class="ttdeci">std::shared_ptr&lt; avsCommon::sdkInterfaces::bluetooth::BluetoothHostControllerInterface &gt; getHostController() override</div><div class="ttdef"><b>Definition:</b> BlueZDeviceManager.cpp:647</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1bluetooth_html_a7717667c8458923f390f6302b54e907a"><div class="ttname"><a href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1bluetooth.html#a7717667c8458923f390f6302b54e907a">alexaClientSDK::avsCommon::utils::bluetooth::MediaStreamingState</a></div><div class="ttdeci">MediaStreamingState</div><div class="ttdoc">An Enum representing the current state of the stream. </div><div class="ttdef"><b>Definition:</b> BluetoothEvents.h:59</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_requires_shutdown.html">alexaClientSDK::avsCommon::utils::RequiresShutdown</a></div><div class="ttdef"><b>Definition:</b> RequiresShutdown.h:32</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager_html_a49dfc271af291a24d3fea19e5fd69082"><div class="ttname"><a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager.html#a49dfc271af291a24d3fea19e5fd69082">alexaClientSDK::bluetoothImplementations::blueZ::BlueZDeviceManager::getAdapterPath</a></div><div class="ttdeci">std::string getAdapterPath() const</div><div class="ttdef"><b>Definition:</b> BlueZDeviceManager.cpp:345</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager_html_a481c68aded0e2cd397b7061d3184d916"><div class="ttname"><a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager.html#a481c68aded0e2cd397b7061d3184d916">alexaClientSDK::bluetoothImplementations::blueZ::BlueZDeviceManager::doShutdown</a></div><div class="ttdeci">void doShutdown() override</div><div class="ttdef"><b>Definition:</b> BlueZDeviceManager.cpp:517</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_managed_g_variant.html">alexaClientSDK::bluetoothImplementations::blueZ::ManagedGVariant</a></div><div class="ttdef"><b>Definition:</b> ManagedGVariant.h:33</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_g_variant_map_reader_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_g_variant_map_reader.html">alexaClientSDK::bluetoothImplementations::blueZ::GVariantMapReader</a></div><div class="ttdef"><b>Definition:</b> GVariantMapReader.h:36</div></div>
<div class="ttc" id="_pairing_agent_8h_html"><div class="ttname"><a href="_pairing_agent_8h.html">PairingAgent.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager_html_a3e32aae45c2a6cb19ba0a2920c270208"><div class="ttname"><a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager.html#a3e32aae45c2a6cb19ba0a2920c270208">alexaClientSDK::bluetoothImplementations::blueZ::BlueZDeviceManager::create</a></div><div class="ttdeci">static std::shared_ptr&lt; BlueZDeviceManager &gt; create(std::shared_ptr&lt; avsCommon::utils::bluetooth::BluetoothEventBus &gt; eventBus)</div><div class="ttdef"><b>Definition:</b> BlueZDeviceManager.cpp:90</div></div>
<div class="ttc" id="namespacealexa_client_s_d_k_html"><div class="ttname"><a href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></div><div class="ttdoc">Whether or not curl logs should be emitted. </div><div class="ttdef"><b>Definition:</b> AVSConnectionManager.h:37</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager_html_ab275c144eabf33f855b81a1ef4821024"><div class="ttname"><a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager.html#ab275c144eabf33f855b81a1ef4821024">alexaClientSDK::bluetoothImplementations::blueZ::BlueZDeviceManager::getMediaEndpoint</a></div><div class="ttdeci">std::shared_ptr&lt; MediaEndpoint &gt; getMediaEndpoint()</div><div class="ttdef"><b>Definition:</b> BlueZDeviceManager.cpp:643</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager_html_a8c5946da10981da8e016c1a9a4179a85"><div class="ttname"><a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager.html#a8c5946da10981da8e016c1a9a4179a85">alexaClientSDK::bluetoothImplementations::blueZ::BlueZDeviceManager::getEventBus</a></div><div class="ttdeci">std::shared_ptr&lt; avsCommon::utils::bluetooth::BluetoothEventBus &gt; getEventBus()</div><div class="ttdef"><b>Definition:</b> BlueZDeviceManager.cpp:651</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager.html">alexaClientSDK::bluetoothImplementations::blueZ::BlueZDeviceManager</a></div><div class="ttdef"><b>Definition:</b> BlueZDeviceManager.h:48</div></div>
<div class="ttc" id="_blue_z_host_controller_8h_html"><div class="ttname"><a href="_blue_z_host_controller_8h.html">BlueZHostController.h</a></div></div>
<div class="ttc" id="_bluetooth_device_manager_interface_8h_html"><div class="ttname"><a href="_bluetooth_device_manager_interface_8h.html">BluetoothDeviceManagerInterface.h</a></div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1bluetooth_1_1_bluetooth_device_manager_interface_html"><div class="ttname"><a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1bluetooth_1_1_bluetooth_device_manager_interface.html">alexaClientSDK::avsCommon::sdkInterfaces::bluetooth::BluetoothDeviceManagerInterface</a></div><div class="ttdef"><b>Definition:</b> BluetoothDeviceManagerInterface.h:36</div></div>
<div class="ttc" id="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager_html_a09c419b25ed4b3f0757feb3d9e9d46de"><div class="ttname"><a href="classalexa_client_s_d_k_1_1bluetooth_implementations_1_1blue_z_1_1_blue_z_device_manager.html#a09c419b25ed4b3f0757feb3d9e9d46de">alexaClientSDK::bluetoothImplementations::blueZ::BlueZDeviceManager::getDiscoveredDevices</a></div><div class="ttdeci">std::list&lt; std::shared_ptr&lt; avsCommon::sdkInterfaces::bluetooth::BluetoothDeviceInterface &gt; &gt; getDiscoveredDevices() override</div><div class="ttdef"><b>Definition:</b> BlueZDeviceManager.cpp:625</div></div>
</div><!-- fragment --></div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
